\chapter{Loop/Plant modification}
In this chapter disturbance leakage on bottom of Tanks 3 and 4 will be introduced. A $H_\infty$ loop-shaping controller has to be designed and the disturbance rejection for leakage will be evaluated.

\section{Nonlinear model for leakage}

Based on the Bernoulli's law the leakage can be modeled as 

\begin{equation}
	\frac{d h}{dt}=-\frac{A_d}{A}\sqrt{2gh}
\end{equation}
where $A_d$ is the cross surface of the leakage, $A$ is the cross surface of the tank and $h$ the height of water. Based on that the mathematical model representing the dynamic of quadruple tank with leakage is derived as follows

\begin{equation}
	\begin{aligned}
	&\frac{dh_1}{dt}=-\frac{a_1}{A_1}\sqrt{2gh_1} + \frac{a_3}{A_1}\sqrt{2gh_3}+\frac{\gamma_1 k_1}{A_1}v_1 \\
	&\frac{dh_2}{dt}=-\frac{a_2}{A_2}\sqrt{2gh_2} + \frac{a_4}{A_2}\sqrt{2gh_4}+\frac{\gamma_2 k_2}{A_2}v_2 \\
	&\frac{dh_3}{dt}=-\frac{a_3}{A_3}\sqrt{2gh_3} - \mathbf{\frac{A_{d30}}{A_3}\sqrt{2gh_3}}+\frac{(1-\gamma_2) k_2}{A_3}v_2 \\
	&\frac{dh_4}{dt}=-\frac{a_4}{A_4}\sqrt{2gh_4} - \mathbf{\frac{A_{d40}}{A_4}\sqrt{2gh_4}}+\frac{(1-\gamma_1) k_1}{A_4}v_1 \\\
	\end{aligned}
\end{equation}


\section{Linearization for leakage}
Making use of first order Taylor expansion on the same operating points as before we get the following state space matrices:

\begin{equation}
\begin{aligned}
&\mathbf{A_{lek}^{mp}}= \begin{bmatrix}
& -\frac{a_1}{A_1}\sqrt{\frac{g}{2h_{10}}} & 0 
& \frac{a_3}{A_1}\sqrt{\frac{g}{2h_{30}}} & 0 \\
& 0 &-\frac{a_2}{A_2}\sqrt{\frac{g}{2h_{30}}} 
& 0 &\frac{a_4}{A_2}\sqrt{\frac{g}{2h_{40}}}  \\
& 0 & 0 & -(\frac{a_3}{A_3}+\frac{A_{d30}}{A_3})\sqrt{\frac{g}{2h_{30}}} & 0\\ 
& 0 & 0 & 0 & -(\frac{a_4}{A_4}+\frac{A_{d40}}{A_4})\sqrt{\frac{g}{2h_{40}}} \\
\end{bmatrix} \\ \\
&\mathbf{B_{lek}^{mp}}=\mathbf{B^{mp}},\quad \mathbf{C_{lek}^{mp}}=\mathbf{C^{mp}},\quad \mathbf{D_{lek}^{mp}}=\mathbf{D^{mp}}
\end{aligned}
\end{equation}
Beside the $\mathbf{A}$ matrix, all other matrices stay the same.
There is no need for scaling on this system because input and output have comparable sizes.

\section{Controller design for leakage}
In $H_\infty$ loop shaping in order to meet the performance requirements one uses pre- and post-compensators to shape the open-loop singular values of the plant followed by coprime robust stabilization step.
Since choosing the pre and post-compensator weights can become a difficult task, we decide to use a PT2 weight for $W_1$ and set $W_2$ to 1.

\begin{equation}
	\begin{aligned}
		W_1=\frac{0.8}{s(s+25)}
	\end{aligned}
\end{equation}

The ncfsyn method on Matlab returns a controller of order 11. The singular value plot of the achieved loop G*K is equal to that of the target loop G*W1 to within plus or minus $\gamma=2.2 dB$. 
%\ref{fig:sys_prop_lek}. 

%\begin{figure}[!h]
%	\centering
%	\includegraphics[width=0.5\textwidth]{images/system_properties_lek}
%	\caption{Robustness and performance}
%	\label{fig:sys_prop_lek}
%\end{figure}

	Step time response for perturbation for minimum phase condition is shown in Fig.~\ref{fig:step_h_inf_loop_shaping}

\begin{figure}[!h]
	\centering
	\includegraphics[width=1\textwidth]{images/step_h_inf_loop_shaping}
	\caption{Step response of the linear and nonlinear system with $H_\infty$ loop shaping controller}
	\label{fig:step_h_inf_loop_shaping}
\end{figure}
\clearpage
\section{Evaluation of disturbance rejection for leakage}
In order to evaluate robust stability and robust performance based on disturbance rejection we use the parametric uncertainty suggested in Task2 and the performance weight:

\begin{equation}
\begin{aligned}
W_P=\frac{0.2s+0.1}{s+0.2}
\end{aligned}
\end{equation}

which includes relative uncertainty of 20\% in steady state and 50\% for high frequencies in all directions. As measurement tool we stick to unstructured singular value analysis.

Before checking NP,RS and RP it was proven that system satisfies nominal stability, by checking the stability of one of the closed loops of the system and making sure that the controller and system don't cancel any RHP-pole or -zero.
As seen from Fig.~\ref{fig:ussv_NP_lek}, Fig.~\ref{fig:ussv_RS_lek} and Fig.~\ref{fig:ussv_RP_lek} we see that robust performance is satisfied.
The structured singular value $\mu_{\Delta}$ is smaller than 1 over all frequencies.


\begin{figure}[!h]
	\centering
	\includegraphics[height=5cm,width=0.5\textwidth]{images/ussv_NP_lek}
	\caption{$\mu_{\Delta_P}(\mathbf{N_{22}})$}
	\label{fig:ussv_NP_lek}
\end{figure}

%\begin{figure}[!h]
%	\centering
%	\includegraphics[width=0.5\textwidth]{images/ussv_RS_lek}
%	\caption{$\mu_{\Delta}(\mathbf{N_{11}})$}
%	\label{fig:ussv_RS_lek}
%\end{figure}
%
%\begin{figure}[!h]
%	\centering
%	\includegraphics[width=0.5\textwidth]{images/ussv_RP_lek}
%	\caption{$\mu_{\Delta*}(\mathbf{N})$}
%	\label{fig:ussv_RP_lek}
%\end{figure}

\begin{figure}
	\centering
	\begin{minipage}{.5\textwidth}
		\centering
		\includegraphics[height=5cm,width=1\linewidth]{images/ussv_RS_lek}
		\captionof{figure}{$\mu_{\Delta}(\mathbf{N_{11}})$}
		\label{fig:ussv_RS_lek}
	\end{minipage}%
	\begin{minipage}{.5\textwidth}
		\centering
		\includegraphics[height=5cm,width=1\linewidth]{images/ussv_RP_lek}
		\captionof{figure}{$\mu_{\Delta^*}(\mathbf{N})$}
		\label{fig:ussv_RP_lek}
	\end{minipage}
\end{figure}


\clearpage
\section{Evaluation of controller based on leakage}
In order to evaluate the controller for disturbance rejection we simulate our system with sinus-disturbances of different frequencies, with amplitude smaller than 1 and see if the amplitude is increased on the output.
This is not the case for our system, since disturbance is not amplified on the output, Fig.~\ref{fig:evaluation_disturb}.


\begin{figure}[!h]
	\centering
	\includegraphics[width=1\textwidth]{images/evaluation_disturbance}
	\caption{Influence of sinus-disturbance over different frequencies}
	\label{fig:evaluation_disturb}
\end{figure}

%\section{$\mu$ -synthesis [A bonus question!!!]}